// Must always have a default choice.
// The default choice must be the last choice.
// All choices, except that last, must end with 'break' or 'return'
// unless it is a fall-through, in which case the last token must
// be a comment.

void okay1()
{
  switch (0) {
    default : ;
  }
}

void okay2()
{
  switch (0) {
    case 0 : break;
    default : ;
  }
}

void okay3()
{
  switch (0) {
    case 0 :            // comment, makes fall-through okay
    case 1 :            // comment, makes fall-through okay
    default : ;
  }
}
void okay4()
{
  switch (0) {
    case 0 :
      if (0)
        break;
      else
        return;
    default : ;
  }
}
void okay5()
{
  switch (0) {
    case 0 :
      if (0)
        1;
      break;
    default: ;
  }
}
void okay6()
{
  switch (0) {
    case 0 : {
      if (0)
        1;
      }
      break;
    default : ;
  }
}
void okay7()
{
  switch (0) {
#ifdef FOO
    case 0 :
      {
        if (0)
          1;
      }
      break;
#endif
    default : ;
  }
}


void violation1()
{
  switch (0) {}         // violation, no default
}

void violation2()
{
  switch (0) {
    default : break;
    case 0 : ;          // violation, case after default
  }
}

void violation3()
{
  switch (0) {
    default :
      switch (1) {}     // violation, no default
  }
}

void violation4()
{
  switch (0) {
    case 0 :
      switch (1) {
        default : ;
      }
  }                     // violation, no default
}

void violation5()
{
  switch (0) {
    case 0 :
    default : ;         // violation, fall-through
  }
}
